<script setup>
import Cropper from "cropperjs";
useHead({
  link: [{ rel: 'stylesheet', href: "https://cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.12/cropper.min.css" }]
})


const emit = defineEmits(["close", "image"]);

const base64ImgValue = ref("");
const showOkButton = computed(() => {
    return base64ImgValue.value != "";
  });

onMounted(() => {
  const input = document.getElementById("inputImage");
  const cropButton = document.getElementById("cropButton");
  const imageContainer = document.getElementById("imageContainer");
  const sourceImage = document.getElementById("sourceImage");
  const croppedImage = document.getElementById("croppedImage");
  // const base64TextArea = document.getElementById("base64TextArea");
  let cropper;


  input.addEventListener("change", function (e) {
    const file = e.target.files[0];
    const reader = new FileReader();

    reader.onload = function (event) {
      sourceImage.src = event.target.result;
    };

    reader.readAsDataURL(file);
  });

  sourceImage.addEventListener("load", function () {
    if (cropper) {
      cropper.destroy();
    }
    cropper = new Cropper(sourceImage, {
      aspectRatio: 199 / 255,
      cropBoxResizable: false,
      ready: function () {
        imageContainer.addEventListener("mousedown", function (e) {
          if (e.target === this) {
            cropper.setDragMode("move");
          }
        });
        imageContainer.addEventListener("mouseup", function () {
          cropper.setDragMode("crop");
        });
      },
    });
  });

  cropButton.addEventListener("click", function (evt) {
    const canvas = cropper.getCroppedCanvas({
      width: 199,
      height: 255,
    });
    croppedImage.src = canvas.toDataURL("image/png");
    // base64TextArea.value = canvas.toDataURL("image/png");
    base64ImgValue.value = canvas.toDataURL("image/png");

    evt.preventDefault();
    });
  });

  function uploadAndClose() {
    if(base64ImgValue.value != "") {
      emit("image", base64ImgValue.value)
    }
    emit("close", true);
  }

  function cancel() {
    emit("close", true);
  }

</script>
<template>
  <div class="bg-white shadow-las border-2 border-las-orange border-solid">
    <div id="buttonContainer">
      <button class="cropperButton" id="quitButton" @click="cancel()">Annuler</button>
      <label for="inputImage" class="cropperButton">Charger image</label>
      <input type="file" id="inputImage" accept=".png" />
      <button class="cropperButton" id="cropButton">Rogner</button>
      <button v-if="showOkButton" class="cropperButton" id="okButton" @click="uploadAndClose()">Ok</button>
    </div>
    <div id="imageContainer">
      <img
        id="sourceImage"
        src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=="
        alt="Source Image"
      />
    </div>
    <img
      id="croppedImage"
      src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=="
      alt="Cropped Image"
    />
    <!-- <textarea id="base64TextArea" readonly></textarea> -->
  </div>
</template>
<style scoped>
#inputImage {
  display: none;
}

.cropperButton {
  background-color: #e58252;
  color: #fff;
  border: none;
  padding: 10px 20px;
  font-size: 16px;
  cursor: pointer;
  border-radius: 5px;
  transition: background-color 0.3s ease;
}

.cropperButton:hover {
  background-color: #b66842;
}

#quitButton {
  background-color: rgb(209, 80, 80);
}
#quitButton:hover {
  background-color: rgb(153, 59, 59);
}

#cropButton {
  background-color: #4db276;
}

#cropButton:hover {
  background-color: #357c52;
}

#imageContainer {
  width: 100%;
  max-width: 500px;
  height: auto;
  border: 1px solid black;
  overflow: hidden;
  margin: 20px auto;
  position: relative;
}

#sourceImage {
  max-width: none;
  max-height: none;
  width: 100%;
  height: 100%;
  object-fit: cover;
}

#croppedImage {
  max-width: 100%;
  height: auto;
  margin: 20px auto;
}

/* #base64TextArea {
  width: 300px;
  margin: 10px auto;
  resize: none;
  height: 100px;
} */

#buttonContainer {
  display: flex;
  justify-content: center;
  margin: 20px auto;
}

.cropperButton {
  margin-right: 10px;
}
</style>
